/**
 * Copyright  Sergey Melnik (Stanford University, Database Group)
 *
 * All Rights Reserved.
 */
package org.w3c.rdf.model;

/**
 * A virtual model may deliver additional facts besides those explicitly contained in the model.
 * For example, a virtual model may contain infinitely many non-materialized facts.
 *
 * @author Sergey Melnik <melnik@db.stanford.edu>
 */

public interface VirtualModel extends Model {

  /**
   * @return model contains the fact basis of this model
   */
  public Model getGroundModel();
}
