package org.w3c.tools.crypt;

import java.security.DigestException;

/**
 * An MD5-based digest.
 */

public class Md5Digest implements Digest {

  byte[] digest;

  public Md5Digest(String str) {

    Md5 md5 = new Md5 (str);
    digest = md5.processString();
  }

  public Md5Digest(String str, String enc) {

    Md5 md5 = new Md5 (str, enc);
    digest = md5.processString();
  }

  public Md5Digest(byte[] digest) throws DigestException {

    if(digest.length != 16)
      throw new DigestException("Md5Digest: wrong number of bytes: " + digest.length + " instead of 16");
    this.digest = digest;
  }

  public String getDigestAlgorithm() {

    return MD5;
  }

  //  public int getDigestLength() {
  //    return 16;
  //  }

  public byte[] getDigestBytes() {

    byte[] result = new byte[16];
    System.arraycopy(digest, 0, result, 0, 16);
    return result;
  }

  public int hashCode() {

    return DigestUtil.digestBytes2HashCode(digest);
  }

  public boolean equals (Object that) {

    if(!(that instanceof Digest))
      return false;

    return DigestUtil.equal(this, (Digest)that);
  }
}
